%	Copyright (c) 2012-2013, Zhu Ning
%	All rights reserved.
%	
%	Redistribution and use in source and binary forms, with or without
%	modification, are permitted provided that the following conditions are met: 
%	
%	1. Redistributions of source code must retain the above copyright notice, this
%	   list of conditions and the following disclaimer. 
%	2. Redistributions in binary form must reproduce the above copyright notice,
%	   this list of conditions and the following disclaimer in the documentation
%	   and/or other materials provided with the distribution. 
%	
%	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
%	ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
%	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
%	DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
%	ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
%	(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
%	LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
%	ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
%	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
%	SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

function [ ret ] = woctave_explore_var(fid, x, var_name)

	str_var_class = class(x);
	size_var = size(x);
	str_1stline = '';
	str_1stline = strcat('>:', str_var_class);
	str_1stline = strcat(str_1stline , '|');
	str_1stline = strcat(str_1stline , var_name);
	str_1stline = strcat(str_1stline , '|');
	str_1stline = strcat(str_1stline ,  num2str(size_var));
	str_1stline = strcat(str_1stline , "\n");
	len_var = 1;
	for i = 1: length(size(x))
		len_var = len_var * (size(x))(i);
	end
	
if( isstruct(x) == 0)

	y = reshape(x, len_var, 1);
	if(iscell(x) == 1)
		vsize = size(x);
		vorder = zeros(1,length(vsize));
		str_1stline(end) = '|';
		str_1stline = strcat(str_1stline, num2str(len_var));
		str_1stline = strcat(str_1stline , "\n");
		fputs(fid, str_1stline);
		for i=1: len_var
		% calculate the idx
		vIdxBase = i-1;
		str_order = '{';
			for j=1: length(vsize)
				vorder(j) = mod(vIdxBase,vsize(j))+1;	
				vIdxBase = floor(vIdxBase./vsize(j));
				str_order = strcat(str_order, num2str(vorder(j)));
				str_order = strcat(str_order, ',');
			end	
		str_order(end) = '}';	
		
		v_mat = cell2mat(y(i));
		str_cell_fieldname = strcat(var_name, str_order);
		woctave_explore_var(fid,v_mat,str_cell_fieldname );
		end
	else
	fputs(fid, char(str_1stline));
	fdisp(fid, y);
	end
else
		
	for m = 1:len_var
		vsize = size(x);
		vorder = zeros(1,length(vsize));
		vIdxBase = m-1;
		str_order = '(';
			for j=1: length(vsize)
				vorder(j) = mod(vIdxBase,vsize(j))+1;	
				vIdxBase = floor(vIdxBase./vsize(j));
				str_order = strcat(str_order, num2str(vorder(j)));
				str_order = strcat(str_order, ',');
			end	
		str_order(end) = ')';	
		
		if (len_var > 1)
			disp_name = strcat(var_name, str_order);
		else
			disp_name = var_name;
		end
	
				
		v_field = fieldnames(x(m));
		fprintf(fid, ">:%s|%s|%s|%d\n", 'struct', char(disp_name),  char(num2str(size(x(m)))),char(length(v_field)));
		for i=1: length(v_field)
		woctave_explore_var(fid, getfield(x(m), v_field(i)),char(v_field(i)));
		end
	
	end
end		
endfunction
